package examen.horloge;

import java.time.LocalTime;
import static org.junit.jupiter.api.Assertions.assertEquals;
import org.junit.jupiter.api.Test;

public class HeureTest {
  @Test
  void testHeureIntIntInt() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    // résultat attendu
    int hAttendue = 12;
    // résultat effectif
    int hEffective = heure.getHeure();
    assertEquals(hAttendue, hEffective, "heure devrait être à 12");
  }
  
  @Test
  void testHeureLocalTime() {
    
    // données de test
    Heure heure = new Heure(LocalTime.now());
    // résultat attendu
    int hAttendue = LocalTime.now().getHour();
    // résultat effectif
    int hEffective = heure.getHeure();
    assertEquals(hAttendue, hEffective, "heure devrait être à 15");
  }
  
  @Test
  void testSetHeure() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    heure.setHeure(13);
    // résultat attendu
    int hAttendue = 13;
    // résultat effectif
    int hEffective = heure.getHeure();
    assertEquals(hAttendue, hEffective, "heure devrait être à 13");
  }
  
  @Test
  void testGetMinute() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    // résultat attendu
    int mAttendue = 14;
    // résultat effectif
    int mEffective = heure.getMinute();
    assertEquals(mAttendue, mEffective, "minute devrait être à 14");
  }
  
  @Test
  void testSetMinute() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    heure.setMinute(54);
    // résultat attendu
    int mAttendue = 54;
    // résultat effectif
    int mEffective = heure.getMinute();
    assertEquals(mAttendue, mEffective, "minute devrait être à 54");
  }
  
  @Test
  void testGetSeconde() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    // résultat attendu
    int sAttendue = 17;
    // résultat effectif
    int sEffective = heure.getSeconde();
    assertEquals(sAttendue, sEffective, "seconde devrait être à 17");
  }
  
  @Test
  void testSetSeconde() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    heure.setSeconde(28);
    // résultat attendu
    int sAttendue = 28;
    // résultat effectif
    int sEffective = heure.getSeconde();
    assertEquals(sAttendue, sEffective, "seconde devrait être à 28");
  }
  
  @Test
  void testHashCode() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    int hc = heure.hashCode();
    // résultat attendu
    int hcAttendu = 41774;
    // résultat effectif
    int hcEffectif = hc;
    assertEquals(hcAttendu, hcEffectif, "hashCode devrait être à 41774");
  }
  
  @Test
  void testEquals() {
    
    Heure h1 = new Heure(12, 14, 17);
    Heure h2 = new Heure(12, 14, 17);
    Heure h3 = null;
    int test = 10;
    Heure h4 = new Heure(LocalTime.now());
    
    boolean attendu1 = true;
    boolean effectif1 = h1.equals(h2);
    assertEquals(attendu1, effectif1, "h1 et h2 devraient être égaux");
    
    boolean attendu2 = false;
    boolean effectif2 = h1.equals(h3);
    assertEquals(attendu2, effectif2, "h1 et h3 ne devraient pas être égaux");
    
    boolean attendu3 = false;
    boolean effectif3 = h1.equals(test);
    assertEquals(attendu3, effectif3, "h1 et test ne devraient pas être égaux");
    
    boolean attendu4 = false;
    boolean effectif4 = h1.equals(h4);
    assertEquals(attendu4, effectif4, "h1 et h4 ne devraient pas être égaux");
    
    h4.setHeure(12);
    boolean attendu5 = false;
    boolean effectif5 = h1.equals(h4);
    assertEquals(attendu5, effectif5, "h1 et h4 ne devraient pas être égaux");
    
    h4.setMinute(14);
    boolean attendu6 = false;
    boolean effectif6 = h1.equals(h4);
    assertEquals(attendu6, effectif6, "h1 et h4 ne devraient pas être égaux");
    
    h4.setSeconde(17);
    boolean attendu7 = true;
    boolean effectif7 = h1.equals(h4);
    assertEquals(attendu7, effectif7, "h1 et h4 devraient être égaux");
  }
}
